GIT 1.4.3-rc1
[git.git] / git-checkout.sh
blob119bca1ffbfb8fb0dae404a8e7389f577aebc42c
1 #!/bin/sh
3 USAGE='[-f] [-b <new_branch>] [-m] [<branch>] [<paths>...]'
4 SUBDIRECTORY_OK=Sometimes
5 . git-sh-setup
7 old_name=HEAD
8 old=$(git-rev-parse --verify $old_name 2>/dev/null)
9 new=
10 new_name=
11 force=
12 branch=
13 newbranch=
14 newbranch_log=
15 merge=
16 while [ "$#" != "0" ]; do
17 arg="$1"
18 shift
19 case "$arg" in
20 "-b")
21 newbranch="$1"
22 shift
23 [ -z "$newbranch" ] &&
24 die "git checkout: -b needs a branch name"
25 git-show-ref --verify --quiet -- "refs/heads/$newbranch" &&
26 die "git checkout: branch $newbranch already exists"
27 git-check-ref-format "heads/$newbranch" ||
28 die "git checkout: we do not like '$newbranch' as a branch name."
30 "-l")
31 newbranch_log=1
33 "-f")
34 force=1
36 -m)
37 merge=1
39 --)
40 break
42 -*)
43 usage
46 if rev=$(git-rev-parse --verify "$arg^0" 2>/dev/null)
47 then
48 if [ -z "$rev" ]; then
49 echo "unknown flag $arg"
50 exit 1
52 new="$rev"
53 new_name="$arg^0"
54 if git-show-ref --verify --quiet -- "refs/heads/$arg"
55 then
56 branch="$arg"
58 elif rev=$(git-rev-parse --verify "$arg^{tree}" 2>/dev/null)
59 then
60 # checking out selected paths from a tree-ish.
61 new="$rev"
62 new_name="$arg^{tree}"
63 branch=
64 else
65 new=
66 new_name=
67 branch=
68 set x "$arg" "$@"
69 shift
71 case "$1" in
72 --)
73 shift ;;
74 esac
75 break
77 esac
78 done
80 # The behaviour of the command with and without explicit path
81 # parameters is quite different.
83 # Without paths, we are checking out everything in the work tree,
84 # possibly switching branches. This is the traditional behaviour.
86 # With paths, we are _never_ switching branch, but checking out
87 # the named paths from either index (when no rev is given),
88 # or the named tree-ish (when rev is given).
90 if test "$#" -ge 1
91 then
92 hint=
93 if test "$#" -eq 1
94 then
95 hint="
96 Did you intend to checkout '$@' which can not be resolved as commit?"
98 if test '' != "$newbranch$force$merge"
99 then
100 die "git checkout: updating paths is incompatible with switching branches/forcing$hint"
102 if test '' != "$new"
103 then
104 # from a specific tree-ish; note that this is for
105 # rescuing paths and is never meant to remove what
106 # is not in the named tree-ish.
107 git-ls-tree --full-name -r "$new" "$@" |
108 git-update-index --index-info || exit $?
110 git-checkout-index -f -u -- "$@"
111 exit $?
112 else
113 # Make sure we did not fall back on $arg^{tree} codepath
114 # since we are not checking out from an arbitrary tree-ish,
115 # but switching branches.
116 if test '' != "$new"
117 then
118 git-rev-parse --verify "$new^{commit}" >/dev/null 2>&1 ||
119 die "Cannot switch branch to a non-commit."
123 # We are switching branches and checking out trees, so
124 # we *NEED* to be at the toplevel.
125 cdup=$(git-rev-parse --show-cdup)
126 if test ! -z "$cdup"
127 then
128 cd "$cdup"
131 [ -z "$new" ] && new=$old && new_name="$old_name"
133 # If we don't have an old branch that we're switching to,
134 # and we don't have a new branch name for the target we
135 # are switching to, then we'd better just be checking out
136 # what we already had
138 [ -z "$branch$newbranch" ] &&
139 [ "$new" != "$old" ] &&
140 die "git checkout: to checkout the requested commit you need to specify
141 a name for a new branch which is created and switched to"
143 if [ "X$old" = X ]
144 then
145 echo "warning: You do not appear to currently be on a branch." >&2
146 echo "warning: Forcing checkout of $new_name." >&2
147 force=1
150 if [ "$force" ]
151 then
152 git-read-tree --reset -u $new
153 else
154 git-update-index --refresh >/dev/null
155 merge_error=$(git-read-tree -m -u $old $new 2>&1) || (
156 case "$merge" in
158 echo >&2 "$merge_error"
159 exit 1 ;;
160 esac
162 # Match the index to the working tree, and do a three-way.
163 git diff-files --name-only | git update-index --remove --stdin &&
164 work=`git write-tree` &&
165 git read-tree --reset -u $new &&
166 git read-tree -m -u --aggressive $old $new $work || exit
168 if result=`git write-tree 2>/dev/null`
169 then
170 echo >&2 "Trivially automerged."
171 else
172 git merge-index -o git-merge-one-file -a
175 # Do not register the cleanly merged paths in the index yet.
176 # this is not a real merge before committing, but just carrying
177 # the working tree changes along.
178 unmerged=`git ls-files -u`
179 git read-tree --reset $new
180 case "$unmerged" in
181 '') ;;
184 z40=0000000000000000000000000000000000000000
185 echo "$unmerged" |
186 sed -e 's/^[0-7]* [0-9a-f]* /'"0 $z40 /"
187 echo "$unmerged"
188 ) | git update-index --index-info
190 esac
191 exit 0
193 saved_err=$?
194 if test "$saved_err" = 0
195 then
196 test "$new" = "$old" || git diff-index --name-status "$new"
198 (exit $saved_err)
202 # Switch the HEAD pointer to the new branch if we
203 # checked out a branch head, and remove any potential
204 # old MERGE_HEAD's (subsequent commits will clearly not
205 # be based on them, since we re-set the index)
207 if [ "$?" -eq 0 ]; then
208 if [ "$newbranch" ]; then
209 if [ "$newbranch_log" ]; then
210 mkdir -p $(dirname "$GIT_DIR/logs/refs/heads/$newbranch")
211 touch "$GIT_DIR/logs/refs/heads/$newbranch"
213 git-update-ref -m "checkout: Created from $new_name" "refs/heads/$newbranch" $new || exit
214 branch="$newbranch"
216 [ "$branch" ] &&
217 GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD "refs/heads/$branch"
218 rm -f "$GIT_DIR/MERGE_HEAD"
219 else
220 exit 1